/*
 * wheelhook  -- hook for wheelfix
 *
 * $Id: wheelhook.c,v 1.1 2003/07/28 07:23:45 hos Exp $
 *
 */

#include <windows.h>
#include "wheelhook.h"


static HINSTANCE dll_instance;

HHOOK hook __attribute__((section ("shared"), shared)) = NULL;


BOOL APIENTRY DllMain(HANDLE module, DWORD reason_for_call, LPVOID rsrv)
{
    if(reason_for_call == DLL_PROCESS_ATTACH) {
        dll_instance = (HINSTANCE)module;
    }

    return TRUE;
}


LRESULT CALLBACK get_message_proc(int code, WPARAM wparam, LPARAM lparam)
{
    if(code == HC_ACTION && wparam == PM_REMOVE) {
        MSG *msg = (MSG *)lparam;

        if(msg != NULL && msg->message == WM_MOUSEWHEEL) {
            HWND wnd = WindowFromPoint(msg->pt);

            if(wnd != msg->hwnd) {
                PostMessage(wnd, msg->message, msg->wParam, msg->lParam);
                msg->message = WM_NULL;
            }
        }
    }

    return CallNextHookEx(hook, code, wparam, lparam);
}


WHEELHOOK_API int set_wheel_fix_hook(void)
{
    if(hook != NULL) {
        return 1;
    }

    hook = SetWindowsHookEx(WH_GETMESSAGE, get_message_proc, dll_instance, 0);
    if(hook == NULL) {
        return 0;
    }

    return 1;
}


WHEELHOOK_API int clear_wheel_fix_hook(void)
{
    if(hook == NULL) {
        return 1;
    }

    {
        int ret;

        ret = UnhookWindowsHookEx(hook);
        hook = NULL;

        if(ret == 0) {
            return 0;
        }
    }

    return 1;
}
